%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calcul des IMFs 
% (avec sifting process)
%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Imodes,Ires]=calculIMFs(I,methode,noModeMax,noIterMax,messages,seuilExtrema)

Imodes=I;
Ires=zeros(size(I));

% Initialisation des variables
noMode=1;
CritereEMD=false;
image=I;

nbMinPrec=length(I)^2;
nbMaxPrec=length(I)^2;

while (true)
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % Calcul d'une IMF - Sifting Process
  ImageCour=image;
  CritereSifting=false;
  noIter=1;
  while (true)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    marge=calculMarge(ImageCour);
    
    % Calcul des enveloppes
    [EnvMin,EnvMax,nbMin,nbMax]=...
	CalculEnveloppes(ImageCour,methode,seuilExtrema,marge);
    
    if  CritereArretSifting(EnvMax,EnvMin,noIter,noIterMax)
      break
    end
    
    moyenneCour=(EnvMax+EnvMin)/2;
    detailCour=ImageCour-moyenneCour;
    %disp(nnz(imregionalmax(detailCour)))
    
    %disp(max(max(detailCour)))
    %disp(min(min(detailCour)))
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % l'itration suivante se fait sur le dtail
    ImageCour=detailCour;
    noIter=noIter+1;
  end

% Mise  jour du critre d'arrt (pour l'EMD)
if (CritereArretEMD(seuilExtrema,noMode,noModeMax,nbMin,nbMax,nbMinPrec,nbMaxPrec))
  return;
end

if (messages)
  disp(['Obtention de l IMF ' num2str(noMode) ', Nb iterations: ' num2str(noIter)])
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% on a calcul une IMF
IMF=detailCour;
residu=image-IMF;
Imodes(:,:,noMode)=IMF;
Ires=residu;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% l'itration suivante se fait sur le rsidu
image=residu;


nbMinPrec=nbMin;
nbMaxPrec=nbMax;
noMode=noMode+1;

end



