
function [Xmin,Ymin,Zmin,  Xmax,Ymax,Zmax,   nbPointsRajoutes]=grilleInterpolation(I,marge)

n=length(I);
I2=double(I);

nbPointsRajoutes=4;

% Calcul des extrema locaux
% extrema: 
Imin=imregionalmin(I);
Imax=imregionalmax(I);


% les valeurs correspondantes, Imin, Imax sont  valeurs dans [1,2]
% (on ajoute translation=1 pour viter les valeurs nulles)
translation=1;
Imin=double(Imin).*(I2+translation);
Imax=double(Imax).*(I2+translation);


% Symtrisation aux bords
Imin=MatriceAugmentee(Imin,marge);
Imax=MatriceAugmentee(Imax,marge);


N=n+2*marge;
valeurArbitraire=-10;
Imin(1,1)=valeurArbitraire;
Imin(1,N)=valeurArbitraire;
Imin(N,1)=valeurArbitraire;
Imin(N,N)=valeurArbitraire;

Imax(1,1)=valeurArbitraire;
Imax(1,N)=valeurArbitraire;
Imax(N,1)=valeurArbitraire;
Imax(N,N)=valeurArbitraire;

[Xmin,Ymin,Zmin]=find(Imin);
[Xmax,Ymax,Zmax]=find(Imax);

% on retire la valeur translation
Zmin=Zmin-translation;
Zmax=Zmax-translation;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% correction des valeurs aux coins
% On recherche les extrema les plus proches
% en excluant les valeurs aux coins de la recherche 

xmin=Xmin;ymin=Ymin;
xmax=Xmax;ymax=Ymax;

indices=(Zmin==valeurArbitraire-translation);
xmin(indices)=10*N; ymin(indices)=10*N;

indices=(Zmax==valeurArbitraire-translation);
xmax(indices)=10*N; ymax(indices)=10*N;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coin (1,1)
d11min=(xmin-1).^2+(ymin-1).^2;
indiceMin=(min(d11min)==d11min);

d11max=(xmax-1).^2+(ymax-1).^2;
indiceMax=(min(d11max)==d11max);

C11min=Zmin(indiceMin);
C11max=Zmax(indiceMax);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coin (1,N)
d1Nmin=(xmin-1).^2+(ymin-N).^2;
indiceMin=(min(d1Nmin)==d1Nmin);

d1Nmax=(xmax-1).^2+(ymax-N).^2;
indiceMax=(min(d1Nmax)==d1Nmax);

C1Nmin=Zmin(indiceMin);
C1Nmax=Zmax(indiceMax);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coin (N,1)
dN1min=(xmin-N).^2+(ymin-1).^2;
indiceMin=(min(dN1min)==dN1min);

dN1max=(xmax-1).^2+(ymax-N).^2;
indiceMax=(min(dN1max)==dN1max);

CN1min=Zmin(indiceMin);
CN1max=Zmax(indiceMax);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coin (N,1)
dNNmin=(xmin-N).^2+(ymin-N).^2;
indiceMin=(min(dNNmin)==dNNmin);

dNNmax=(xmax-N).^2+(ymax-N).^2;
indiceMax=(min(dNNmax)==dNNmax);

CNNmin=Zmin(indiceMin);
CNNmax=Zmax(indiceMax);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Valeurs corriges

Zmin(and(Xmin==1,Ymin==1))=C11min(1);
Zmin(and(Xmin==1,Ymin==N))=C1Nmin(1);
Zmin(and(Xmin==N,Ymin==1))=CN1min(1);
Zmin(and(Xmin==N,Ymin==N))=CNNmin(1);

Zmax(and(Xmax==1,Ymax==1))=C11max(1);
Zmax(and(Xmax==1,Ymax==N))=C1Nmax(1);
Zmax(and(Xmax==N,Ymax==1))=CN1max(1);
Zmax(and(Xmax==N,Ymax==N))=CNNmax(1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%







