function [transformees,correlation]=simulationBruit(tailleImage,sigma,tailleEchantillon,nbmodes)

% - simulation d'un bruit
% - analyse par EMD
% - analyse de Fourier

% tailleImage: ex. images 64x64
% tailleEchantillon: ex. 50 images 
% nbmodes: nombre de modes analyss (ex. 6)
% sigma: cart-type du bruit simul 
% 
% transformee: N x N x NbModes x tailleEchantillon

transformees=zeros(tailleImage,tailleImage,nbmodes,tailleEchantillon);

methode='cubic';
noModeMax=6;
noIterMax=3;
messages=false;
typeAffichage='';
seuilExtrema=tailleImage/8;
marge=tailleImage/8;

rand('seed',0)

%MatriceCorrelation=zeros(nbmodes,nbmodes,tailleEchantillon);

for indice=1:tailleEchantillon
  disp(indice)
  bruit=sigma*randn(tailleImage,tailleImage);
  [Imodes,Ires,TF]=emd2d(bruit, ...
			 messages,typeAffichage,...
			 methode,noModeMax,noIterMax,...
			 seuilExtrema,marge);
  
  % Corrlation 
  %MatriceCorrelation(:,:,indice)=orthogonalite(Imodes,nbmodes);
  
  
  for noMode=1:size(TF,3)
    tf=TF(:,:,noMode);
    transformees(:,:,noMode,indice)=tf;
  end
end

%correlation=mean(MatriceCorrelation,3)
correlation=0;

moyenne=mean(transformees,4);

for k=1:nbmodes
  fourier=moyenne(:,:,k);
  figure
  %imagesc(fourier), colorbar
  imagesc(fourier,'XData',[-1/2 1/2], 'YData',[-1/2 1/2])
  
  barre=colorbar;
  set(barre,'FontSize',24)

  xlabel('\nu_1','FontSize',24)
  ylabel('\nu_2','FontSize',24)
  titre=['Mode ' num2str(k)];
  title(titre,'FontSize',24)

  axis square
  v=[-0.5 -0.25 0 0.25 0.5];
  
  set(gca,'XTick',v)
  set(gca,'YTick',v)
  set(gca,'FontSize',20)

  
end

n=length(moyenne);
milieu=length(moyenne)/2;
t=0:milieu;
u=log(t);

figure

coupe=zeros(6,milieu+1);
coupeDiag=zeros(6,milieu+1);
for k=1:6
  fourier=moyenne(:,:,k);
  coupe(k,:)=fourier(milieu,milieu:n);
  for indice=milieu:n
    coupeDiag(k,indice-milieu+1)=fourier(indice,indice);
  end
end

plot(t,coupe)
plot(t,coupeDiag)

lissage=zeros(6,milieu+1);
for k=1:6
  st=csaps(t,coupeDiag(k,:),0.5);
  lissage(k,:)=fnval(st,t);
end

figure(2)
plot(t,lissage)

st=csaps(t,coupeDiag(1,:),0.1);
lissage1=fnval(st,t);

line(t,lissage1)


st=csaps(t,coupeDiag(2,:),0.6);
lissage2=fnval(st,t);

line(t,lissage2)
line(t,coupeDiag(2,:))


st=csaps(t,coupeDiag(3,:),0.6);
lissage3=fnval(st,t);

line(t,lissage3)
line(t,coupeDiag(3,:))

st=csaps(t,coupeDiag(4,:),0.8);
lissage4=fnval(st,t);

line(t,lissage4)
line(t,coupeDiag(4,:))

st=csaps(t,toto,0.6);
lissage4=fnval(st,t);

line(t,lissage4)
line(t,toto)



plot(t,lissage1)
line(t,lissage2)
line(t,lissage3)
line(t,lissage4)


for k=1:6
  [val,indice]=max(coupe(k,:));
  disp(indice/33*0.5)
end